<div class="flex flex-col h-screen">
  <mat-card class="m-4">
    <mat-card-header class="m-2">
      <mat-card-title>
        <div class="flex">
          <button class="secondary-icon mr-3" (click)="back()"><mat-icon>keyboard_backspace</mat-icon></button>

        {{ name || "New LDAP Client" }}        </div>
      </mat-card-title>
    </mat-card-header>
    <mat-card-content class="flex flex-col">
      <form [formGroup]="ldapClientForm">
        <mat-form-field class="w-full">
          <mat-label>LDAP Client Provider</mat-label>
          <input matInput formControlName="name" required>
          <mat-checkbox formControlName="isDisabled" matSuffix
            >Disable LDAP</mat-checkbox>
          <mat-checkbox formControlName="skipMobileVerification" matSuffix
            >Skip Mobile Verification</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Description</mat-label>
          <input matInput formControlName="description">
          <mat-checkbox formControlName="disableUserCreation" matSuffix >Disable User Creation</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>URL</mat-label>
          <input matInput formControlName="url">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Admin DN</mat-label>
          <input matInput formControlName="adminDn">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Admin Password</mat-label>
          <input matInput formControlName="adminPassword"
            [type]="hideAdminPassword ? 'password' : 'text'">
          <mat-icon matSuffix
            (click)="hideAdminPassword = !hideAdminPassword">{{hideAdminPassword
            ? 'visibility_off' :
            'visibility'}}</mat-icon>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>User Search Base</mat-label>
          <input matInput formControlName="userSearchBase" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Username Attribute</mat-label>
          <input matInput formControlName="usernameAttribute" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Email Attribute</mat-label>
          <input matInput formControlName="emailAttribute">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Phone Attribute</mat-label>
          <input matInput formControlName="phoneAttribute">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Full Name Attribute</mat-label>
          <input matInput formControlName="fullNameAttribute" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Timeout</mat-label>
          <input matInput formControlName="timeoutMs" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Allowed Failed Login Attempts</mat-label>
          <input matInput formControlName="allowedFailedLoginAttempts" required>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Client ID</mat-label>
          <mat-select formControlName="clientId">
            <mat-option *ngFor="let client of clientList"
              [value]="client.clientId">
              {{ client.name + " (" + client.clientId + ")"}}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Scope</mat-label>
          <mat-select formControlName="scope">
            <mat-option *ngFor="let scope of scopeList" [value]="scope.name">
              {{ scope.name }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <div
          *ngFor="let scp of ldapClientForm.get('attributes')['controls']; let i = index;"
          formArrayName="attributes">
          <div [formGroupName]="i">
            <mat-form-field class="w-1/2 pr-3">
              <mat-label>Claim</mat-label>
              <input matInput formControlName="claim">
            </mat-form-field>
            <mat-form-field class="w-1/2">
              <mat-label>Map To</mat-label>
              <input matInput formControlName="mapTo">
              <button mat-icon-button color="accent" matSuffix
                (click)="removeAttribute(i)">
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
        <button mat-button color="accent" (click)="addAttribute()">
          Add Attribute<mat-icon>add</mat-icon>
        </button>
        <mat-checkbox formControlName="isSecure" matSuffix
          class="client-checkboxes">Is Secure</mat-checkbox>
        <mat-form-field class="w-full">
          <mat-label>key</mat-label>
          <textarea matInput formControlName="key"></textarea>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Key Passphrase</mat-label>
          <input matInput formControlName="keyPassphrase"
            [type]="hideKeyPassphrase ? 'password' : 'text'">
          <mat-icon matSuffix
            (click)="hideKeyPassphrase = !hideKeyPassphrase">{{hideKeyPassphrase
            ? 'visibility_off' :
            'visibility'}}</mat-icon>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>cert</mat-label>
          <textarea matInput formControlName="cert"></textarea>
        </mat-form-field>
        <div
          *ngFor="let scp of ldapClientForm.get('ca')['controls']; let i = index;"
          formArrayName="ca">
          <div [formGroupName]="i">
            <mat-form-field class="w-1/2">
              <mat-label>CA {{i+1}}</mat-label>
              <textarea matInput formControlName="ca"></textarea>
              <button mat-icon-button color="accent" matSuffix
                (click)="removeCA(i)">
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
        <button mat-button color="accent" (click)="addCA()">
          Add CA<mat-icon>add</mat-icon>
        </button>
      </form>
    </mat-card-content>
    <mat-card-actions class="m-4 flex flex-row gap-2">
      <button (click)="createLDAPClient()" mat-flat-button color="primary"
        [disabled]="!ldapClientForm.valid"
        *ngIf="!uuid">Create</button>
      <button (click)="updateLDAPClient()" mat-flat-button color="primary"
        [disabled]="!ldapClientForm.valid"
        *ngIf="uuid">Update</button>
      <button (click)="delete()" mat-flat-button color="warn"
        *ngIf="uuid && uuid !== new">Delete</button>
    </mat-card-actions>
  </mat-card>
</div>